// This file is part of GHome Mover (http://www.brookepeig.com/ghomemover)
// GHome Mover was created by Daniel Brooke Peig (daniel@brookepeig.com, http://www.brookepeig.com)
//
//
//
//    GHome Mover is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    GHome Mover is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with GHome Mover; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

// Custom Functions

#include "custom_func.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/stat.h>
#include <sys/types.h>

// SMART file selecting tool
// Please help me to improve this filter
// Return 0 if the file needs to be changed or 1 if it needs to be ignored.
int smart_file_select(char *filename)
{
	char items_to_ignore[100][10];
	char lower_filename[256];
	int i;
	struct stat stat_file;
	
	stat(filename, &stat_file);
	
	// Ignores files bigger than 500KB (I think there s no configuration file bigger than this)
	if (stat_file.st_size >= 500000) return 1;
	
	strcpy(lower_filename, strtolower(filename));
	strcat(lower_filename, "--"); // Just to know where is the end of the file
	
	// Lowercase all strings (helps with performance since it does not need to lower it)
	// Include the "--" at the end of each string (will help a lot in the comparision and speed).
	strcpy (items_to_ignore[0], ".jpg--");
	strcpy (items_to_ignore[1], ".gif--");
	strcpy (items_to_ignore[2], ".png--");
	strcpy (items_to_ignore[3], ".bmp--");
	strcpy (items_to_ignore[4], ".ico--");
	strcpy (items_to_ignore[5], ".exe--");
	strcpy (items_to_ignore[6], ".gz--");
	strcpy (items_to_ignore[7], ".tar--");
	strcpy (items_to_ignore[8], ".rpm--");
	strcpy (items_to_ignore[9], ".zip--");
	strcpy (items_to_ignore[10], ".pdf--");
	strcpy (items_to_ignore[11], ".mp3--");
	strcpy (items_to_ignore[12], ".wav--");
	strcpy (items_to_ignore[13], ".png--");
	strcpy (items_to_ignore[14], ".ogg--");
	strcpy (items_to_ignore[15], ".snd--");
	strcpy (items_to_ignore[16], ".png--");
	strcpy (items_to_ignore[17], ".smf--");
	strcpy (items_to_ignore[18], ".sdp--");
	strcpy (items_to_ignore[19], ".sdd--");
	strcpy (items_to_ignore[20], ".sxi--");
	strcpy (items_to_ignore[21], ".sti--");
	strcpy (items_to_ignore[22], ".ps--");
	strcpy (items_to_ignore[23], ".xls--");
	strcpy (items_to_ignore[24], ".sdc--");
	strcpy (items_to_ignore[25], ".sxc--");
	strcpy (items_to_ignore[26], ".stc--");
	strcpy (items_to_ignore[27], ".dvi--");
	strcpy (items_to_ignore[28], ".kil--");
	strcpy (items_to_ignore[29], ".rtf--");
	strcpy (items_to_ignore[30], ".sdw--");
	strcpy (items_to_ignore[31], ".sxw--");
	strcpy (items_to_ignore[32], ".stw--");
	strcpy (items_to_ignore[33], ".kwd--");
	strcpy (items_to_ignore[34], ".rtx--");
	strcpy (items_to_ignore[35], ".lyx--");
	strcpy (items_to_ignore[36], ".sds--");
	strcpy (items_to_ignore[37], ".sda--");
	strcpy (items_to_ignore[38], ".sxd--");
	strcpy (items_to_ignore[39], ".std--");
	strcpy (items_to_ignore[40], ".jpe--");
	strcpy (items_to_ignore[41], ".jpeg--");
	strcpy (items_to_ignore[42], ".tif--");
	strcpy (items_to_ignore[43], ".tiff--");
	strcpy (items_to_ignore[44], ".dwg--");
	strcpy (items_to_ignore[45], ".dxf--");
	strcpy (items_to_ignore[46], ".3ds--");
	strcpy (items_to_ignore[47], ".ag--");
	strcpy (items_to_ignore[48], ".emf--");
	strcpy (items_to_ignore[49], ".psd--");
	strcpy (items_to_ignore[50], ".sgi--");
	strcpy (items_to_ignore[51], ".wmf--");
	strcpy (items_to_ignore[52], ".xcf--");
	strcpy (items_to_ignore[53], ".xpm--");
	strcpy (items_to_ignore[54], ".xwd--");
	strcpy (items_to_ignore[55], ".iso--");
	strcpy (items_to_ignore[56], ".lzo--");
	strcpy (items_to_ignore[57], ".tzo--");
	strcpy (items_to_ignore[58], ".bz--");
	strcpy (items_to_ignore[59], ".bz2--");
	strcpy (items_to_ignore[60], ".arj--");
	strcpy (items_to_ignore[61], ".3ds--");
	strcpy (items_to_ignore[62], ".deb--");
	strcpy (items_to_ignore[63], ".gtar--");
	strcpy (items_to_ignore[64], ".rar--");
	strcpy (items_to_ignore[65], ".mp2--");
	strcpy (items_to_ignore[66], ".mpe--");
	strcpy (items_to_ignore[67], ".vob--");
	strcpy (items_to_ignore[68], ".wad--");
	strcpy (items_to_ignore[69], ".mov--");
	strcpy (items_to_ignore[70], ".qt--");
	strcpy (items_to_ignore[71], ".avi--");
	strcpy (items_to_ignore[72], ".movie--");
	strcpy (items_to_ignore[73], ".fli--");
	strcpy (items_to_ignore[74], ".flc--");
	strcpy (items_to_ignore[75], ".aw--");
	strcpy (items_to_ignore[76], ".abw--");
	strcpy (items_to_ignore[77], ".aiff--");
	strcpy (items_to_ignore[78], ".aif--");
	strcpy (items_to_ignore[79], ".drv--");
	strcpy (items_to_ignore[80], ".dll--");
	strcpy (items_to_ignore[81], ".so--");
	strcpy (items_to_ignore[82], ".ram--");
	strcpy (items_to_ignore[83], ".tgz--");
	strcpy (items_to_ignore[84], ".bin--");
	strcpy (items_to_ignore[85], ".rar--");
	strcpy (items_to_ignore[86], ".cdr--");
	strcpy (items_to_ignore[87], ".com--");
	strcpy (items_to_ignore[88], ".jar--");
	strcpy (items_to_ignore[89], ".msi--");
	
	
	for (i = 0; i <= 89; i++) // This is faster than any comparation
	{
		if (strstr(lower_filename,items_to_ignore[i]) != NULL)
		{
		return 1;
		}
	}
	
	
	return 0;
}

// Search and replace strings
// Thanks to Boulat (www.boulat.net);
char *replacestr(char *subject, char *search, char *replace)
{
    char *loc           = NULL;
    char *temp          = NULL;
    char *orig          = NULL;
    int diff, size;
    static char *result = NULL;
			
    /* Sanity checks */
    if ((search == NULL) || (replace == NULL) || (subject == NULL)) {
        return NULL;
    }

    /* Free memory from the previous Str_Replace */
    if (result != NULL) {
        free (result);
    }

    /* XXX: very rough approximation for memory allocation */
    diff = strlen(replace) - strlen(search);
    if (diff > 0) {
        /* worse case senario */
        size = (diff+1) * strlen(subject);
    }
    else {
        size = strlen(subject);
    }
    result = (char *)calloc(size + 1, sizeof(char)); 

    temp = strdup(subject);
    orig = temp;
    while ((loc = strstr(temp, search)) != NULL) {
        strncat(result, temp, loc - temp);
        strcat(result, replace);
        temp = loc + strlen(search);
    }    

    if (strlen(temp) > 0) {
       strcat(result, temp);
    }   

    /* cleanup */
    free(orig);

    return result;
}

// Lists the contents of the directory and saves as ghm_dir_list.txt in
// the root of this dir.
// This function may need some "calibration"
// with parameters if you change it please let me know (for improving new versions).
int index_files(char *directory)
{
	char *commando = malloc (256 + strlen(directory));
	
	//Erases the old ghm_dirlist.txt
	strcpy (commando, "rm ");
	strcat(commando, directory);
	strcat(commando, "/ghm_dirlist.txt");
	system(commando);
	
	strcpy (commando,"ls --file-type --all --recursive -x --no-group -1 "); // "ls" command - this is where calibration goes.
	strcat(commando, directory);
	strcat(commando, " >> ");
	strcat(commando, directory);
	strcat(commando, "/ghm_dirlist.txt");
	return system(commando);
}

// Copies all the files from SOURCE DIR to DEST DIR
// This function may need some "calibration"
// with parameters if you change it please let me know (for improving new versions).
int copy_files(char *source, char *destination)
{
	char *commando = malloc (256 + strlen(source) + strlen(destination));
	strcpy (commando,"cp --preserve --recursive --no-dereference --force "); // "cp" command - this is where calibration goes.
	strcat (commando, source);
	strcat (commando, "/. ");
	strcat (commando, destination);
	return system(commando);
}

// Search and replace ocorrencies of a string in file
int search_replace_onfile(char *filename, char *to_search, char *to_replace)
{
	//Local variables
	 FILE *pfile;
	 FILE *ptmpfile;
	 struct stat stat_file;
	 int found; //Checks if we had found something in this file
	 
	 found = 0; //Dummy
	
	 stat(filename, &stat_file); //Get the file size	 
	 
	 char *fileline = malloc(stat_file.st_size); //A line from the file
	 
	 

	// Checks if we can open the files
	if ((ptmpfile = tmpfile()) == NULL || (pfile = fopen(filename, "r")) == NULL)
	{
		return 1;
	}	
	
	// Replaces the strings and writes to a tmp file
	while (fgets(fileline, stat_file.st_size, pfile) != NULL) 
	{
	if (found == 0 && strstr(fileline, to_search) != NULL) found = 1;
	fputs(replacestr(fileline, to_search, to_replace),ptmpfile);		
	}
		
	fclose(pfile);
	rewind(ptmpfile);
	
	// Writes tmp file to original file
	
	// First of all verify if we made at least a replacement
	// (if not we can kick off this part)	
	if (found != 0)
		{
		// Checks if we can open the file for writing
		if ((pfile = fopen(filename, "w")) == NULL)
		{
			return 1;
		}
		
		//Writes the contents of the temporary file
		while (fgets(fileline, stat_file.st_size, ptmpfile) != NULL) 
		{
			fputs(fileline,pfile);
		}
		
		fclose(pfile);
		}
	
	fclose(ptmpfile);
	free(fileline);
	
	return 0;
}

// Changes attributes (owner/group) of the files in a dir
// This function may need some "calibration"
// with parameters if you change it please let me know (for improving new versions).
int dir_chown(char *filename, char *old_user, char *new_user, char *old_group, char *new_group)
{
	char *commando = malloc(256 + strlen(old_user) + strlen(new_user) + strlen(old_group) + strlen(new_group));
	strcpy (commando,"chown -h --recursive --from="); // "chown" command - this is where calibration goes.
	strcat (commando, old_user);
	strcat (commando, ":");
	strcat (commando, old_group);
	strcat (commando, " ");
	strcat (commando, new_user);
	strcat (commando, ":");
	strcat (commando, new_group);
	strcat (commando, " ");
	strcat (commando, filename);
	return system(commando);
}

// Search and Replace a string within a file name
int search_replace_filename(char *filename, char *dir, char *to_search, char *to_replace)
{
	char *commando = malloc(256 + strlen(to_search) + strlen(to_replace));
	strcpy(commando, "mv ");
	strcat(commando, dir);
	strcat(commando, "/");
	strcat(commando, filename);
	strcat(commando, " ");
	strcat(commando, dir);
	strcat(commando, "/");
	strcat(commando, replacestr(filename,to_search,to_replace));
	return system(commando);
}

// Lowercase a string
// Thanks to Boulat (www.boulat.net)
char *strtolower (char *str)
{
    static char *result = NULL;
    int i = 0;

    /* Sanity check */
    if (str == NULL) {
        return NULL;
    }

    /* Free memory from the previous substr */
    if (result != NULL) {
        free (result);
    }


    result = (char *)calloc(strlen(str) + 1, sizeof(char)); 

    strcpy(result, str);
    i = strlen(result) - 1;

    while (i >= 0) {
        if (isupper(result[i])) {
            result[i] = tolower(result[i]);
        }
        i--;
    }
   
    return result;
}
