// This file is part of GHome Mover (http://www.brookepeig.com/ghomemover)
// GHome Mover was created by Daniel Brooke Peig (daniel@brookepeig.com, http://www.brookepeig.com)
//
//
//
//    GHome Mover is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    GHome Mover is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with GHome Mover; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


// Custom functions


// SMART file selecting tool
// Please help me to improve this filter
// Return 0 if the file needs to be changed or 1 if it needs to be ignored.
int smart_file_select(char *filename);

// Search and replace in strings
// Thanks to Boulat (www.boulat.net);
char *replacestr(char *subject, char *search, char *replace);

// Lists the contents of the directory and saves as ghm_dir_list.txt
// This function may need some "calibration"
// with parameters if you change it please let me know (for improving new versions).
int index_files(char *directory);

// Copies all the files from SOURCE DIR to DEST DIR
// This function may need some "calibration"
// with parameters if you change it please let me know (for improving new versions).
int copy_files(char *source, char *destination);

// Search and replace ocorrencies of a string in file
int search_replace_onfile(char *filename, char *to_search, char *to_replace);

// Changes attributes (owner/group) of the files in a dir
// This function may need some "calibration"
// with parameters if you change it please let me know (for improving new versions).
int dir_chown(char *filename, char *old_user, char *new_user, char *old_group, char *new_group);

// Search and Replace a string within a file name
int search_replace_filename(char *filename, char *dir, char *to_search, char *to_replace);

// Lowercase a string
// Thanks to Boulat (www.boulat.net)
char *strtolower (char *str);
